
#property copyright "Code written by Veera360"
#property link      "Veerainfosoln- Veerainfosoln@gmail.com  - 0091-9840-646-368 India."


extern bool     EachTickMode           = True;
extern double   Lots                   = 1.0;
extern int      Slippage               = 30;
extern bool     UseStopLoss            = False;
extern int      StopLoss               = 400;
extern bool     UseTrailingStop        = False;
extern int      TrailingStop           = 200;
extern int      ActivateTrailAfter     = 400;
extern bool     UseTakeProfit          = False;
extern int      TakeProfit             = 100;
extern int      MagicNumber            = 112358;
extern int      ChartTiming            = 1;
extern int      SecondsAllowed         = 60;

int      BarCount;
int      Current;
bool     TickCheck   = False;

int      SymbOrdTot;
int      OrdersCount;
int      SymbOrdTicket;

double UpTrendSignal1;
double DownTrendSignal1;
double UpTrendSignal2;
double DownTrendSignal2;


int init() 
{
   BarCount = Bars;
   if (EachTickMode) Current = 0; else Current = 1;
   return(0);
}


int deinit() 
{
   return(0);
}


int start() 
{
   UpTrendSignal1 = iCustom(Symbol(),NULL,"SmartCandles",0,1);
   DownTrendSignal1 = iCustom(Symbol(),NULL,"SmartCandles",1,1);
   UpTrendSignal2 = iCustom(Symbol(),NULL,"SmartCandles",0,2);
   DownTrendSignal2 = iCustom(Symbol(),NULL,"SmartCandles",1,2);
   ////Print(UpTrendSignal1 + "   " + DownTrendSignal1);   

   if(Period() != ChartTiming) 
   {
      Alert ("This EA is set for " + ChartTiming + "Minute Timing. Please Change Chart Timing");
      return(0);
   }

   int Ticket;
   double StopLossLevel, TakeProfitLevel;

   //+------------------------------------------------------------------+
   //To Get How Many Orders Are Related to Current Symbol
   //+------------------------------------------------------------------+
   SymbOrdTot  =  0;
   for (OrdersCount = 0; OrdersCount < OrdersTotal(); OrdersCount ++) 
   {
      OrderSelect(OrdersCount, SELECT_BY_POS);
      if (OrderSymbol() == Symbol() && OrderComment() == "SmartCandles") 
      {
         SymbOrdTot = SymbOrdTot + 1;  
         SymbOrdTicket = OrderTicket();        
      }
   }
   ////Print("SmartCandles Order   " + SymbOrdTot);   
   //+------------------------------------------------------------------------------------------+
   
   
   
   //////////////////////////////////////////////////////////////////////////////////////////
   if (SymbOrdTot == 0) 
   {
      if (TimeCurrent() - Time[0] > SecondsAllowed)
      {
         return(0);
      }
      ////+------------------------------------------------------------------------------------------+
      ////BUY
      ////+------------------------------------------------------------------------------------------+
      if (UpTrendSignal1 > DownTrendSignal1 && DownTrendSignal2 > UpTrendSignal2) 
      {
         /////Print("UpTrendSignal1 > DownTrendSignal1");
         //Check Free Margin
         if (AccountFreeMargin() < (1000 * Lots)) 
         {
            Print("Not Enough Money. Free Margin = ", AccountFreeMargin());
            return(0);
         }
         //StopLoss & TakeProfit
         if (UseStopLoss) StopLossLevel = Ask - StopLoss * Point; else StopLossLevel = 0.0;
         if (UseTakeProfit) TakeProfitLevel = Ask + TakeProfit * Point; else TakeProfitLevel = 0.0;
         ///Opening Buy
         Ticket = OrderSend(Symbol(), OP_BUY, Lots, Ask, Slippage, StopLossLevel, TakeProfitLevel, "SmartCandles", MagicNumber, 0, DodgerBlue);
         if(Ticket > 0) 
         {
            if (OrderSelect(Ticket, SELECT_BY_TICKET, MODE_TRADES)) 
            {
			      Print("BUY Order Opened : ", OrderOpenPrice());
   			}
         } else
         {
		    Print("Error Opening BUY order : ", GetLastError());
			}
      }
      ////+------------------------------------------------------------------------------------------+
      ////SELL
      ////+------------------------------------------------------------------------------------------+
      if (DownTrendSignal1  > UpTrendSignal1 && UpTrendSignal2 > DownTrendSignal2)
      {
         ////Print("DownTrendSignal1 > UpTrendSignal1");
         //Check Free Margin
         if (AccountFreeMargin() < (1000 * Lots)) 
         {
            Print("Not Enough Money. Free Margin = ", AccountFreeMargin());
            return(0);
         }
         //StopLoss & TakeProfit
         if (UseStopLoss) StopLossLevel = Bid + StopLoss * Point; else StopLossLevel = 0.0;
         if (UseTakeProfit) TakeProfitLevel = Bid - TakeProfit * Point; else TakeProfitLevel = 0.0;
         ///Opening SELL
         Ticket = OrderSend(Symbol(), OP_SELL, Lots, Bid, Slippage, StopLossLevel, TakeProfitLevel, "SmartCandles", MagicNumber, 0, DeepPink);
         if(Ticket > 0) 
         {
            if (OrderSelect(Ticket, SELECT_BY_TICKET, MODE_TRADES)) 
            {
               Print("SELL Order Opened : ", OrderOpenPrice());
		    	}
         }else
         {
           Print("Error Opening SELL Order : ", GetLastError());
			}
      }
      ////+------------------------------------------------------------------------------------------+
      ////+------------------------------------------------------------------------------------------+
   }else
   if (SymbOrdTot == 1) 
   {
      OrderSelect(SymbOrdTicket, SELECT_BY_TICKET);

      if (OrderType() == OP_BUY)
      {
          ////Close BUY
         if (DownTrendSignal1 > UpTrendSignal1)
         {
            ////Print("DownTrendSignal1 > UpTrendSignal1");
            OrderClose(OrderTicket(),OrderLots(),Bid,Slippage,MediumSeaGreen);
         }
         ////Trailing Stop for BUY Order
         if((iHigh(Symbol(), 0, 0) - OrderOpenPrice()) > ActivateTrailAfter * Point)
         {
            if(UseTrailingStop && TrailingStop > 0) 
            {
               if(OrderStopLoss() <  (iHigh(Symbol(), 0, 0) - Point * TrailingStop) || OrderStopLoss() == 0)
               {
                  OrderModify(OrderTicket(), OrderOpenPrice(), iHigh(Symbol(), 0, 0) - Point * TrailingStop, OrderTakeProfit(), 0, MediumSeaGreen);
               }
            }
         }

      }else
      if (OrderType() == OP_SELL)
      {
         ////Close SELL
         if (UpTrendSignal1 > DownTrendSignal1)
         {
            ////Print("UpTrendSignal1 > DownTrendSignal1");
            OrderClose(OrderTicket(),OrderLots(),Ask,Slippage,Pink);
         }
         ////Trailing Stop for SELL Order
         if((OrderOpenPrice() - iLow(Symbol(), 0, 0)) > ActivateTrailAfter * Point)
         {
            if(UseTrailingStop && TrailingStop > 0) 
            {
               if(OrderStopLoss() > (iLow(Symbol(), 0, 0) + Point * TrailingStop) || OrderStopLoss() == 0) 
               {
                  OrderModify(OrderTicket(), OrderOpenPrice(), iLow(Symbol(), 0, 0) + Point * TrailingStop, OrderTakeProfit(), 0, DarkOrange);
               }
            }
         }
      }   
   }
}
//////////////////////////////////////////////////////////////////////////////////////////





